#include <Windows.h>
#include <tchar.h>
#include <assert.h>
#include <locale.h>

bool _GetLogFileName(TCHAR* szTmpFilePath, const TCHAR* szFileName = _T("Log"))
{
	bool bRes = false;
	TCHAR szTmpDir[MAX_PATH]	= {0};
	if (0 != GetTempPath(MAX_PATH, szTmpDir) && 0 != GetTempFileName(szTmpDir, szFileName, 0, szTmpFilePath))
	{
		bRes = true;
	}

	return bRes;
}

void _TraceLogInfo(TCHAR* szTmpFilePath, const TCHAR* szLogInfo)
{
	HANDLE hFile;
	if (NULL != szTmpFilePath)
	{		
		hFile = CreateFile(szTmpFilePath, GENERIC_WRITE, FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, NULL);
		if (INVALID_HANDLE_VALUE != hFile)
		{
			DWORD dwWrote	= 0;
			SetFilePointer(hFile, FILE_END, NULL, FILE_END);

#ifdef _UNICODE
			UINT nLogSize = _tcslen(szLogInfo) + 1;
			// char* szMBSContent = new char[nLogSize];
			char szMBSContent[MAX_PATH * 3] = {0};
			_wsetlocale(LC_ALL, _T("")); 
			nLogSize = wcstombs(szMBSContent, szLogInfo, nLogSize * sizeof(TCHAR));
			WriteFile(hFile, szMBSContent, nLogSize, &dwWrote, NULL);
			//delete[] szMBSContent;
#else
			WriteFile(hFile, szLogInfo, _tcslen(szLogInfo), &dwWrote, NULL);
#endif
			CloseHandle(hFile);
		}
	}

	return;
}

struct TMSGType
{
	int		m_nMinBound;
	int		m_nMaxBound;
	TCHAR	m_szMsgType[64];
};

static 
const TMSGType MSGTypeList[] = {
	{0x0001, 0x00087, _T("Ϣ")},		{0x00A0, 0x00A9, _T("ǿͻϢ")},
	{0x0100, 0x0108,  _T("Ϣ")},		{0x0111, 0x0126, _T("˵Ϣ")},
	{0x0132, 0x0138,  _T("ɫϢ")},	{0x0200, 0x020A, _T("Ϣ")},
	{0x0211, 0x0213,  _T("˵ѭϢ")},	{0x0220, 0x0230, _T("ĵϢ")},
	{0x03E0, 0x03E8,  _T("DDEϢ")},		{0x0400, 0x7FFF, _T("ԶϢ")},
	{0XFF00, 0XFFFF,  _T("ҵϢ")}	
};

bool _IsTraceMessage(const TCHAR* szComment, HWND hWnd, UINT nMsg, WPARAM wParam, LPARAM lParam, int nMsgTypeID)
{
	int nCount = sizeof(MSGTypeList) / sizeof(*MSGTypeList);
	assert(0 <= nMsgTypeID && nMsgTypeID < nCount);
	
	bool bRes = false;
	if (nMsg >= MSGTypeList[nMsgTypeID].m_nMinBound && nMsg <= MSGTypeList[nMsgTypeID].m_nMaxBound)
	{
		bRes = true;
	}

	return bRes;
}

const TCHAR* _GetMsgTypeName(int nMsgTypeID)
{
	int nCount = sizeof(MSGTypeList) / sizeof(*MSGTypeList);
	assert(0 <= nMsgTypeID && nMsgTypeID < nCount);

	if (0 <= nMsgTypeID && nMsgTypeID < nCount)
	{
		return MSGTypeList[nMsgTypeID].m_szMsgType;
	}

	return _T(" ");
}

const int g_nMsgType = 10;
void _PrintMessage(const TCHAR* szComment, HWND hWnd, UINT nMsg, WPARAM wParam, LPARAM lParam)
{
	const TCHAR* szMsgTypeName = _GetMsgTypeName(g_nMsgType);

	static 
	TCHAR s_szTmpFilePath[MAX_PATH] = {0};
	if (NULL == *s_szTmpFilePath)
	{
		_GetLogFileName(s_szTmpFilePath);	
	}
	
	if (_IsTraceMessage(szComment, hWnd, nMsg, wParam, lParam, g_nMsgType))
	{
		TCHAR szTmp[MAX_PATH * 3]; 
		_stprintf(szTmp, _T("%s\t[hWnd = 0X%05X,\t\tMsgID = 0X%04X, \t\twParam = 0X%08X, \t\tlParam = 0X%08X] -- %s\r\n"), 
				  szComment, hWnd, nMsg, wParam, lParam, szMsgTypeName);
		_TraceLogInfo(s_szTmpFilePath, szTmp);
	}
		
	if (nMsg == WM_QUIT)
	{
		ShellExecute(NULL, _T("open"), _T("notepad.exe"), s_szTmpFilePath, NULL, SW_SHOW);
	}
	
	return;
}